/**
 * Copyright (c) 2001-2006 eXo Platform SARL, http://www.exoplatform.com/
 *
 * All rights reserved. Please look at license.txt in info directory for
 * more license detail.
 *
 * -------------------------------------------------------------------------
 * $Id: Signer.java 9137 2006-09-27 01:41:57Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.exoplatform.applications.signerclient.crypto.jce;

import java.security.InvalidKeyException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.SignatureException;

/**
 * @version $Rev: 9137 $ $Date: 2006-09-27 08:41:57 +0700 (Wed, 27 Sep 2006) $
 * @author <a href="mailto:rafael.marins@exoplatform.com">Rafael Marins</a>
 */
public interface Signer {

	String getAlgorithm();

	void initVerify(PublicKey publicKey) throws InvalidKeyException;

	void initSign(PrivateKey privateKey) throws InvalidKeyException;

	byte[] sign() throws SignatureException;

	boolean verify(byte[] sigBytes) throws SignatureException;

}