package org.exoplatform.faces.cms.component;


import java.util.List;

import org.exoplatform.faces.core.Selector;
import org.exoplatform.faces.core.SelectorHandler;
import org.exoplatform.faces.core.component.UIInput;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;

public class MultiValueSelector extends UISimpleForm implements Selector{
  private SelectorHandler handler_ ;
  private String returnValue_ ;
  
  public MultiValueSelector() {
    super("MultiValueSelector", "post", null) ;
    setRendererType("SimpleFormVelocityRenderer") ;  
    UIStringInput values = new UIStringInput("values", "") ;
    add(values) ;    
    
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
    addActionListener(SaveActionListener.class, SAVE_ACTION) ;
  }
  
  public String getInputValue() { return returnValue_; }
  public String[] getParameters() { return null; }
  public void setHandler(SelectorHandler handler) { handler_ = handler ; }
  public void setParameters(String[] arg0) {}
  
  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      MultiValueSelector uiForm = (MultiValueSelector) event.getSource() ;
      uiForm.handler_.cancel(uiForm) ;
    }
  }
  
  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      MultiValueSelector uiForm = (MultiValueSelector) event.getSource() ;
      List values = uiForm.getMultipleValuesUIInput("values") ;
      String returnValue = "" ;
      for(int i = 0; i < values.size(); i++) {
        UIInput value = (UIInput)values.get(i) ;
        if(value.getValue() != null) {
          if(returnValue.length() > 0) returnValue = returnValue + "; " + value.getValue() ;
          else returnValue = value.getValue() ;
        }          
      }
      uiForm.returnValue_ = returnValue ;
      uiForm.handler_.select(uiForm) ;
      uiForm.setRendered(false) ;
    }    
  } 
}
