package org.exoplatform.portlets.content.drives.component;

import java.util.List;

import org.exoplatform.faces.core.component.UICheckBox;
import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.services.cms.views.ManageViewService;
import org.exoplatform.services.cms.views.impl.ViewDataImpl;

public class UIViewList extends UISimpleForm {
  
  private ManageViewService vservice_ ;
  private List views_ ;
  public UIViewList(ManageViewService vservice) {
    super("uiViewList", "post", null) ;
    setRendererType("SimpleFormVelocityRenderer") ;
    vservice_ = vservice ;
    addActionListener(CancelActionListener.class, CANCEL_ACTION) ;
    addActionListener(SaveActionListener.class, SAVE_ACTION) ;
  }
  
  public void update(List seletedList) throws Exception{
    views_ = vservice_.getAllViews() ;
    for(int i = 0; i < views_.size(); i ++) {
      String viewName = ((ViewDataImpl)views_.get(i)).getName() ;
      UICheckBox checkbox = new UICheckBox(viewName, "") ;
      if(seletedList != null && seletedList.size() > 0){
        for(int j = 0 ; j < seletedList.size() ; j ++){
          if(seletedList.get(j).equals(viewName)){
            checkbox.setSelect(true) ;
            break ;
          } 
        }
      }
      add(checkbox) ;
    }    
  }
  
  public List getViews() {
    return views_ ;
  }
  
  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIViewList uiForm = (UIViewList) event.getSource() ;
      uiForm.setRenderedSibling(UIDriveForm.class) ;      
    }
  }
  
  static public class SaveActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UIViewList uiForm = (UIViewList) event.getSource() ;
      StringBuffer selectedView = new StringBuffer() ;
      for(int i = 0 ; i < uiForm.views_.size(); i ++){
        String viewName = ((ViewDataImpl)uiForm.views_.get(i)).getName() ;
        boolean checked = uiForm.getUICheckBox(viewName).getSelect() ;
        if(checked){
          if(selectedView.length() > 0)
            selectedView.append(", ") ;
          selectedView.append(viewName) ;
        } 
      }      
      UIDriveForm driveForm = (UIDriveForm)uiForm.getSibling(UIDriveForm.class) ;
      driveForm.getUIStringInput("views").setValue(selectedView.toString()) ;
      uiForm.setRenderedSibling(UIDriveForm.class) ;
    }    
  }
}
