/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.jcr;

import java.io.IOException;
import java.io.InputStream;
import java.util.List;

import javax.jcr.Node;
import javax.jcr.Property;
import javax.jcr.Session;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.exoplatform.container.PortalContainer;
import org.exoplatform.container.RootContainer;
import org.exoplatform.services.cms.templates.TemplateService;
import org.exoplatform.services.jcr.RepositoryService;
/**
 * Created by The eXo Platform SARL        .
 * Sun, Dec 28, 2003 @ 14:57 
 * @author: Tuan Nguyen
 * @version: $Id: FileContentServlet.java,v 1.3 2004/06/23 03:19:01 tuan08 Exp $
 * @email: tuan08@yahoo.com
 */
public class RssServlet extends HttpServlet {
  public void init(ServletConfig config) throws ServletException {}  
	public void service(HttpServletRequest request, HttpServletResponse response) 
          throws ServletException, IOException {
    response.setHeader("Cache-Control", "private max-age=600, s-maxage=120");
    String wsName = null ;
    String path = null ;
    String portalName = null ;
    String pathInfo = request.getPathInfo() ;
    portalName = pathInfo.substring(1, pathInfo.indexOf("/", 1)) ;
    wsName = pathInfo.substring(portalName.length() + 2, pathInfo.indexOf("/", portalName.length() + 2)) ;
    path = pathInfo.substring(pathInfo.indexOf(wsName)+ wsName.length() + 1) ;
    PortalContainer pcontainer = getPortalContainer(portalName) ;
    PortalContainer.setInstance(pcontainer) ;
    RepositoryService repositoryService = 
      (RepositoryService)pcontainer.getComponentInstanceOfType(RepositoryService.class) ;
    TemplateService tservice = 
      (TemplateService)pcontainer.getComponentInstanceOfType(TemplateService.class) ;
    try{
      Session session = repositoryService.getRepository().getSystemSession(wsName) ;
      Node rootNode = session.getRootNode() ;
      Node file = null ;
      if(rootNode.hasNode(path))
        file = rootNode.getNode(path) ;
      else if(rootNode.hasNode(path.substring(0, path.lastIndexOf("/")))){
        Node parentNode = rootNode.getNode(path.substring(0, path.lastIndexOf("/"))) ;
        String name = path.substring(path.lastIndexOf("/") + 1) ;
          if(name.indexOf(".") > -1 && parentNode.hasNode(name.substring(0, name.indexOf("."))))
            file = parentNode.getNode(name.substring(0, name.indexOf("."))) ;
      }
      if (file == null) throw new Exception("Node " + path + " not found. ");
      Node content;
      if(file.isNodeType("nt:file")) {
        content = file.getNode("jcr:content");
        Property data = content.getProperty("jcr:data");
        String mimeType = content.getProperty("jcr:mimeType").getString();
        response.setContentType(mimeType) ;
        InputStream is = data.getStream();
        byte[] buf = new byte[is.available()];
        is.read(buf);
        ServletOutputStream os = response.getOutputStream();
        os.write(buf);
      } else if (file.isNodeType("exo:rss-enable")){
        List documentNodeType = tservice.getDocumentTemplates() ;
        String nodeType = file.getPrimaryNodeType().getName() ;
        if(documentNodeType.contains(nodeType)){
          String templateName = tservice.getTemplatePath(false, nodeType, "view1") ;
          request.setAttribute("portalName", portalName) ;
          request.setAttribute("wsName", wsName) ;
          request.setAttribute("templateName", "jcr:"+templateName) ;
          request.setAttribute("curNode", file) ;
          RequestDispatcher rd = request.getRequestDispatcher("/viewcontent");
          rd.forward(request, response);
        }else {
          throw new Exception("This node type is not document node");
        }
      } else throw new Exception("Invalid node type, expected nt:file or exo:rss-enable type");
    }catch(Exception e) {
      e.printStackTrace() ;
      throw new ServletException(e) ;
    }    		
	}  
  
  private  PortalContainer getPortalContainer(String portalName) {
    PortalContainer pcontainer =  RootContainer.getInstance().getPortalContainer(portalName) ;
    return pcontainer ;
  }
}
