/***************************************************************************
 * Copyright 2001-2003 The eXo Platform SARL         All rights reserved.  *
 * Please look at license.txt in info directory for more license detail.   *
 **************************************************************************/
package org.exoplatform.portlets.content.jcr.component;

import java.util.List;

import javax.jcr.Node;
import javax.jcr.PathNotFoundException;
import javax.jcr.Session;
import javax.portlet.PortletPreferences;

import org.apache.commons.lang.StringUtils;
import org.exoplatform.container.PortalContainer;
import org.exoplatform.faces.FacesUtil;
import org.exoplatform.faces.core.component.UIPortlet;
import org.exoplatform.services.jcr.RepositoryService;

/**
 * Wed, Dec 22, 2003 @ 23:14 
 * @author: Tuan Nguyen
 * @email:   tuan08@users.sourceforge.net
 * @version: $Id: UIFilePortlet.java,v 1.3 2004/08/17 13:07:02 tuan08 Exp $
 */
public class UIJCRPortlet extends UIPortlet {
	private PortletPreferences prefs_ ;
	private String workspaceName_ ;
	private String jcrPath_ ;
	public UIJCRPortlet(UIWorkspaceBrowser browser,UIJCRExplorer explorer, 
			                UIPreferencesForm preferencesForm) throws Exception {
		setRendererType("ChildrenRenderer") ;
		setId("UIJCRPortlet") ; 
    RepositoryService repositoryService = 
			(RepositoryService)PortalContainer.getComponent(RepositoryService.class) ;		
		prefs_ = FacesUtil.getPortletPreferences() ;  
		workspaceName_ = prefs_.getValue(Utils.WORKSPACE_NAME, "") ;
		jcrPath_ = prefs_.getValue(Utils.JCR_PATH, "") ;
		if(workspaceName_ == null||workspaceName_.length()==0) {
			browser.setRendered(true) ;
			explorer.setRendered(false) ;
		}else {    	 
			Session session = repositoryService.getRepository().login(workspaceName_) ;
			int i = StringUtils.split(jcrPath_,"/").length ;    	
			Node node = null ;
			do {    		
				try {
					if(jcrPath_.length()==0||jcrPath_==null) {
						jcrPath_ = "/";
					}  
					node = (Node)session.getItem(jcrPath_) ;
					break ;
				}catch(PathNotFoundException e) {
					i-- ;
					jcrPath_= StringUtils.substringBeforeLast(jcrPath_, "/") ;     			  		
				}
			}while(i>=0) ;
			if(node!=null) {
				explorer.setSession(session) ;
				explorer.setSelectNode(node) ;
				browser.setRendered(false) ;
				explorer.setRendered(true) ;
			}    	
		}
		preferencesForm.setRendered(false);
		List list = getChildren();
		list.add(explorer) ;
		list.add(browser) ;
		list.add(preferencesForm) ;
	}   

}