package org.exoplatform.portlets.content.versions.component;

import javax.jcr.Node;
import javax.jcr.version.Version;

import org.exoplatform.faces.core.component.UISimpleForm;
import org.exoplatform.faces.core.component.UIStringInput;
import org.exoplatform.faces.core.event.ExoActionEvent;
import org.exoplatform.faces.core.event.ExoActionListener;
import org.exoplatform.portal.Information;
import org.exoplatform.portlets.content.jcr.JCRExceptionManager;
import org.exoplatform.portlets.content.jcr.component.ChangeNodeListener;
import org.exoplatform.portlets.content.jcr.component.UIJCRExplorer;

public class UILabelForm extends UISimpleForm implements ChangeNodeListener {

  final static public String INPUT_NAME = "name";
  protected Node node_;
  protected Version version_;

  public UILabelForm() throws Exception {
    super("UILabelForm", "post", null);
    setRendererType("SimpleFormVelocityRenderer");

    add(new UIStringInput("name", ""));

    addActionListener(AddLabelActionListener.class, SAVE_ACTION);
    addActionListener(CancelActionListener.class, CANCEL_ACTION);
  }

  public void onChange(UIJCRExplorer uiExplorer, Node node) throws Exception {
    setRendered(false);
    node_ = node;
  }
  
  public void setVersion(Version version) {  version_ = version; }  

  public Node getNode() { return node_; }

  static public class AddLabelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UILabelForm uicomp = (UILabelForm) event.getSource();
      String label = uicomp.getUIInput(INPUT_NAME).getValue();
      Information iprovider = findInformationProvider(uicomp);
      try {
        String versionName = uicomp.version_.getName();
        uicomp.node_.getVersionHistory().addVersionLabel(versionName, label, true);
        uicomp.setRenderedSibling(UIVersionInfo.class);
      } catch (Exception e) {
        JCRExceptionManager.process(iprovider, e);
      }
    }
  }
  
  static public class CancelActionListener extends ExoActionListener {
    public void execute(ExoActionEvent event) throws Exception {
      UILabelForm uicomp = (UILabelForm) event.getSource();
      uicomp.setRenderedSibling(UIVersionInfo.class);  
    }
  }  
}
